GMGenie.Macros.Mail = {};

GMGenie.Macros.Mail.curMailMessage = '';


function GMGenie.Macros.Mail.run(name, title)
	local text = GMGenie_SavedVars.mail[title].macro;
    local text = string.gsub(text, "NAME", name);
    local lines = {strsplit("\n",text)};
    local subject = GMGenie_SavedVars.mail[title].subject;
    
    for index,line in pairs(lines) do
        local command = '.send mail '..name..' "'..subject;
        if #lines > 1 then
            command = command..' '..index..'/'..(#lines);
        end
        local command = command..'" "'..line..'"';
        SendChatMessage(command, "GUILD");
    end
end

function GMGenie.Macros.Mail.runFromSpy()
    if GMGenie.Spy.currentRequest["name"] then
        GMGenie.Macros.Mail.run(GMGenie.Spy.currentRequest["name"], this.value);
    end
end

function GMGenie.Macros.Mail.addToUnitMenu()
    UnitPopupMenus["GMGenie_Mail"] = {};
    local MailTemp = GMGenie.pairsByKeys2(GMGenie_SavedVars.mail);
    for index,name in pairs(MailTemp) do
        table.insert(UnitPopupMenus["GMGenie_Mail"], "GMGenie_Mail_"..name);
        UnitPopupButtons["GMGenie_Mail_"..name] = { text = name, dist = 0,};
    end
    
    table.insert(UnitPopupMenus["GMGenie_Mail"], "GMGenie_MailOptions");
	UnitPopupButtons["GMGenie_MailOptions"] = { text = "Manage macros", dist = 0,};
end

function GMGenie.Macros.Mail.loadDropdown(self, level)
    local info = UIDropDownMenu_CreateInfo();
    info.hasArrow = false;
    info.notCheckable = true;
    info.isTitle = true;
    info.text = "Mail Macros";
    UIDropDownMenu_AddButton(info, level);
    
    local MailTemp = GMGenie.pairsByKeys2(GMGenie_SavedVars.mail);
    for index,name in pairs(MailTemp) do
        local info = UIDropDownMenu_CreateInfo();
        info.hasArrow = false;
        info.notCheckable = true;
        info.text = name;
        info.func = GMGenie.Macros.Mail.runFromSpy;
        info.value = name;
        UIDropDownMenu_AddButton(info, level);
    end
    
    local info = UIDropDownMenu_CreateInfo();
    info.hasArrow = false;
    info.notCheckable = true;
    info.text = "Manage Macros";
    info.func = GMGenie.Macros.Mail.showOptions;
    UIDropDownMenu_AddButton(info, level);
end