GMGenie.Macros = {};

function GMGenie.Macros.onLoad()
    GMGenie.Macros.menuItems = {};
    
    UnitPopupButtons["GMGenie_Commands"] = { text = "Quick Commands", dist = 0, nested = 1};
    table.insert(GMGenie.Macros.menuItems, "Commands");
    UnitPopupMenus["GMGenie_Commands"] = {};
    
    UnitPopupButtons["GMGenie_Revive"] = { text = "Revive", dist = 0};
    table.insert(UnitPopupMenus["GMGenie_Commands"], "GMGenie_Revive");
    UnitPopupButtons["GMGenie_Appear"] = { text = "Appear", dist = 0};
    table.insert(UnitPopupMenus["GMGenie_Commands"], "GMGenie_Appear");
    UnitPopupButtons["GMGenie_Summon"] = { text = "Summon", dist = 0};
    table.insert(UnitPopupMenus["GMGenie_Commands"], "GMGenie_Summon");
    UnitPopupButtons["GMGenie_Freeze"] = { text = "Freeze", dist = 0};
    table.insert(UnitPopupMenus["GMGenie_Commands"], "GMGenie_Freeze");
    UnitPopupButtons["GMGenie_Unfreeze"] = { text = "Unfreeze", dist = 0};
    table.insert(UnitPopupMenus["GMGenie_Commands"], "GMGenie_Unfreeze");
    UnitPopupButtons["GMGenie_Spy"] = { text = "Spy", dist = 0};
    table.insert(UnitPopupMenus["GMGenie_Commands"], "GMGenie_Spy");
    
	UnitPopupButtons["GMGenie_Whispers"] = { text = "Whisper Macros", dist = 0, nested = 1};
    table.insert(GMGenie.Macros.menuItems, "Whispers");
    GMGenie.Macros.Whispers.addToUnitMenu();
    
	UnitPopupButtons["GMGenie_Mail"] = { text = "Mail Macros", dist = 0, nested = 1};
    table.insert(GMGenie.Macros.menuItems, "Mail");
    GMGenie.Macros.Mail.addToUnitMenu();
    
	UnitPopupButtons["GMGenie_Tele"] = { text = "Teleport Macros", dist = 0, nested = 1};
    table.insert(GMGenie.Macros.menuItems, "Tele");
    GMGenie.Macros.Tele.addToUnitMenu();
    
    for i, button in ipairs(GMGenie.Macros.menuItems) do
        table.insert(UnitPopupMenus["PLAYER"], #UnitPopupMenus["PLAYER"]-1, "GMGenie_"..button);
        table.insert(UnitPopupMenus["FRIEND"], #UnitPopupMenus["FRIEND"]-1, "GMGenie_"..button);
        table.insert(UnitPopupMenus["PARTY"], #UnitPopupMenus["PARTY"]-1, "GMGenie_"..button);
        table.insert(UnitPopupMenus["RAID_PLAYER"], #UnitPopupMenus["RAID_PLAYER"]-1, "GMGenie_"..button);
        table.insert(UnitPopupMenus["TEAM"], #UnitPopupMenus["TEAM"]-1, "GMGenie_"..button);
        table.insert(UnitPopupMenus["CHAT_ROSTER"], #UnitPopupMenus["CHAT_ROSTER"]-1, "GMGenie_"..button);
    end

	hooksecurefunc("UnitPopup_OnClick", GMGenie.Macros.contextMenuClick);
end

function GMGenie.Macros.contextMenuClick()
	local dropdownFrame = UIDROPDOWNMENU_INIT_MENU;
	local button = this.value;
	local name = dropdownFrame.name;
	local startPos = string.find(button, "GMGenie_");
	
	if (startPos == 1) then
        button = string.sub(button, 9);
	    
        if button == "Revive" then
            GMGenie.Macros.revive(name);
        elseif button == "Appear" then
            GMGenie.Macros.appear(name);
        elseif button == "Summon" then
            GMGenie.Macros.summon(name);
        elseif button == "Freeze" then
            GMGenie.Macros.freeze(name);
        elseif button == "Unfreeze" then
            GMGenie.Macros.unfreeze(name);
        elseif button == "Spy" then
            GMGenie.Spy.spy(name);
        elseif button == "WhisperOptions" then
            GMGenie.Macros.Whispers.showOptions();
        elseif button == "MailOptions" then
            GMGenie.Macros.Mail.showOptions();
        elseif button == "TeleOptions" then
            GMGenie.Macros.Tele.showOptions();
        else
            local isWhisperMacro = string.find(button, "Whispers_");
            local isMailMacro = string.find(button, "Mail_");
            local isTeleMacro = string.find(button, "Tele_");
            if isWhisperMacro == 1 then
                GMGenie.Macros.Whispers.run(name, string.sub(button, 10));
            elseif isMailMacro == 1 then
                GMGenie.Macros.Mail.run(name, string.sub(button, 6));
            elseif isTeleMacro == 1 then
                GMGenie.Macros.Tele.run(name, string.sub(button, 6));
            end
        end
	end
    
    return;
end

function GMGenie.Macros.loadDropdown(self, level)
    local level = level or 1;
    
    if level == 1 then
        local info = UIDropDownMenu_CreateInfo();
        info.hasArrow = true;
        info.notCheckable = true;
        info.text = "Whisper Macros";
        info.value = "whispers";
        UIDropDownMenu_AddButton(info, level);
        
        local info = UIDropDownMenu_CreateInfo();
        info.hasArrow = true;
        info.notCheckable = true;
        info.text = "Mail Macros";
        info.value = "mail";
        UIDropDownMenu_AddButton(info, level);
        
        local info = UIDropDownMenu_CreateInfo();
        info.hasArrow = true;
        info.notCheckable = true;
        info.text = "Teleport Macros";
        info.value = "tele";
        UIDropDownMenu_AddButton(info, level);
        
    elseif level == 2 then
        if UIDROPDOWNMENU_MENU_VALUE == "whispers" then
            GMGenie.Macros.Whispers.loadDropdown(self, level);
        elseif UIDROPDOWNMENU_MENU_VALUE == "mail" then
            GMGenie.Macros.Mail.loadDropdown(self, level);
        elseif UIDROPDOWNMENU_MENU_VALUE == "tele" then
            GMGenie.Macros.Tele.loadDropdown(self, level);
        end
    end
end

function GMGenie.Macros.revive(name)
    SendChatMessage(".revive "..name, "GUILD");
end

function GMGenie.Macros.appear(name)
    SendChatMessage(".appear "..name, "GUILD");
end

function GMGenie.Macros.summon(name)
    SendChatMessage(".summon "..name, "GUILD");
end

function GMGenie.Macros.freeze(name)
    SendChatMessage(".freeze "..name, "GUILD");
end

function GMGenie.Macros.unfreeze(name)
    SendChatMessage(".unfreeze "..name, "GUILD");
end